/*
 File: wysuwyg_library.js
 Copyright: Rahul Singh
 Mail: induscrypt@gmail.com
 Source: http://wysuwyg.mozdev.org
 Referenced by: wysuwyg_library.xul
 Description: An RDF based repository for displaying user-saved code/syle/text library
 			Tree based display.		
 			
*/

debugEnabled=true; //debug mode, passed explicitly by the overlay

var wysLibrary = {

 MAXSNIP:32, //Max num of entries
 MAXCHARS:2048, 
 SNIPFILE:null,
 SNIPTREE: null,
 CURRSNIP:null, //currently selected snippet
 TITLARRAY:null,
 dirService: null,
 IOService: null,
 rdfService: null,
 containerUtils: null,
 
 

 initLibTree: function()
{
 
 	try{

	dirService = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties); 
	IOService= Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
	rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].
                   getService(Components.interfaces.nsIRDFService);
    containerUtils = Components.classes['@mozilla.org/rdf/container-utils;1']. 
                                 getService(Components.interfaces.nsIRDFContainerUtils);               
                   
	myDir = dirService.get("ProfD", Components.interfaces.nsIFile);
	myDir.append("wysuwyg");
	
	if ( !myDir.exists() )
		{
			myDir.create(myDir.DIRECTORY_TYPE, 0700);
			
		}
	myDir.append("wys_library.rdf");	
	
	
	if ( !myDir.exists() )
		{
			/*start hiding new 
			myJarDir = dirService.get("CurProcD", Components.interfaces.nsIFile);//current -this- dir
			myJarDir.append("data");
			myJarDir.append("wys_samplelibrary.rdf");
			alert(myJarDir.path);
			myJarDir.copyTo ( myDir.parent , "wys_library.rdf" );			
			end hiding new  */			
			
			myDir.create(myDir.NORMAL_FILE_TYPE, 0666);			
			var fileURL = IOService.newFileURI(myDir).spec;				
			var ds = rdfService.GetDataSourceBlocking(fileURL);		
			var newresource=rdfService.GetResource("http://wysuwyg.mozdev.org/all-snippets");
			var aSequence = containerUtils.MakeSeq(ds,newresource);			
			ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
			ds.Flush();	
			SNIPFILE= IOService.newFileURI(myDir).spec; 
			//add some initial content	
			var tmpstr=	"&lt;b&gt;This is a sample.&lt;/b&gt; Use controls below to add more " ;	
			this.saveEntry("default","Sample(Drag)",tmpstr,(new Date()).toString());
			return;						
		}
	
	 
	//else
	    SNIPFILE= IOService.newFileURI(myDir).spec;
	 //build tree
	 
	 
	}catch (ex)	{if(debugEnabled) alert("wySUwyg: Error initialising \n  snippet library \n " + ex.message);}

},


 

//query tree for selected element
//argument: 1=date (hidden ) 2=title column entry
 queryLibTree : function(aQuery)
{ 
	
  var libtree=SNIPTREE;
  var indx = libtree.currentIndex;
  if (indx == -1) return null;
  if (aQuery==1) var dt = libtree.view.getCellText(indx, libtree.columns["wyslib_dt"]);
  if (aQuery==2) var dt = libtree.view.getCellText(indx, libtree.columns["wyslib_title"]);
  return dt; 
 
},


 saveEntry: function(cl,title,snip,dt)
{
	
	try{


	var ds=rdfService.GetDataSourceBlocking(SNIPFILE);
	
	var newresource=rdfService.GetResource("http://wysuwyg.mozdev.org/all-snippets");	
	var aSequence = containerUtils.MakeSeq(ds,newresource);	
	//check if you've topped the max limit
	
	if (aSequence.GetCount() >= wysLibrary.MAXSNIP)
	{
		window.alert("sorry, Only " + wysLibrary.MAXSNIP + " Entries Allowed!");
		ds.Flush();
		aSequence=null; newresource=null; ds=null; 
		return;
	}
	
	var subject = rdfService.GetResource("http://wysuwyg.mozdev.org/ed-snippets/"+dt);
	
	var predicate = rdfService.GetResource("http://wysuwyg.mozdev.org/rdf#snip-class");
	var name = rdfService.GetLiteral(cl);	
	ds.Assert(subject, predicate, name, true);
	
	
	var predicate0 = rdfService.GetResource("http://wysuwyg.mozdev.org/rdf#snip-title");
	var name0 = rdfService.GetLiteral(title);	
	ds.Assert(subject, predicate0, name0, true);
	
	var predicate1 = rdfService.GetResource("http://wysuwyg.mozdev.org/rdf#snip-snippet");
	var name1 = rdfService.GetLiteral(snip);
	ds.Assert(subject, predicate1, name1, true);
	
	
	var predicate2 = rdfService.GetResource("http://wysuwyg.mozdev.org/rdf#timestamp");
	var name2 = rdfService.GetLiteral(dt);
	ds.Assert(subject, predicate2, name2, true);
	
	//now try adding to list
	
	
	
	
	aSequence.AppendElement(subject);
	
	
	
	ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
	ds.Flush();	
	
	//libtree.builder.rebuild( );
	
	} catch(ex) { if(debugEnabled) alert("wySUwyg: Error adding to \nsnippet library \n " + ex.message); }

},


//prompt and save
 addLibEntry: function()
 {
	if(!confirm("Save Editor's current \ncontent for reuse?"))return;
	var titl=window.prompt("Give a title for this entry");
	if (!titl ) return;
	if ( (titl.length>0) && (titl.match(/[^\s]/)!=null))
	{	 if (titl.length>15){alert("Title can't be more than 15 characters long!");return;}
		//else
		 var str=this.getEditorContent();
		 if (str==null) {alert("Error! Can't get editor content!"); return;}
		 //else
		 if ((l=str.length) >= wysLibrary.MAXCHARS){alert("Sorry, you cannot save snippets \nmore than "+wysLibrary.MAXCHARS+" characters long!\n Found: "+ l + " characters.");return;}
		 if (s=str.match(/<script/)){alert("Sorry, you cannot add \nscripts to snippets!\n Found: "+s);return;}
		 if (t=str.match(/<[^>\n]*</)){alert("Found open tags!\n "+t);return;}
		 var dt=(new Date()).toString();
		 this.saveEntry("default",titl,str,dt ) ; // default class for now, hierarchical trees later //function(cl,title,snip,dt)
	}
	else(alert("Error while saving!\nTitle too Short? "));
 
 },


 removeEntry: function()
{	if (!this.queryLibTree(2)) return;
	if (!window.confirm("Really delete Code Snippet '"+ this.queryLibTree(2) + "'?" ) ) return;
	try{
	var ds=rdfService.GetDataSourceBlocking(SNIPFILE);
	var dt=this.queryLibTree(1);
	//find what contains this date
	
	var subject = rdfService.GetResource("http://wysuwyg.mozdev.org/ed-snippets/"+dt);
	var newresource=rdfService.GetResource("http://wysuwyg.mozdev.org/all-snippets");
	
	var aSequence = containerUtils.MakeSeq(ds,newresource);
	aSequence.RemoveElement(subject,true);
	ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
	wysLibrary.removeResource  ( ds, subject);
	ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
	ds.Flush();
	
	//var libtree=SNIPTREE;
	//libtree.builder.rebuild( );
	} catch(ex) { if(debugEnabled)alert ("wySUwyg: Error removing entry \nfrom snippet Library \n"+ ex.message); if(ds) ds=null;}
},



//remove one resource from RDF root
removeResource: function  ( datasource, res)
	{
		var names = datasource.ArcLabelsOut(res);
		
		while ( names.hasMoreElements() )
		{
			//try {
				var name  = names.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
				var value = datasource.GetTarget(res, name, true);
				datasource.Unassert(res, name, value);
			//} catch(ex) {
			//}
		}		
	},

//build tree 
updateLibtree: function(tr)
{
	 SNIPTREE=tr;
	 var ds=rdfService.GetDataSource(SNIPFILE);
	 SNIPTREE.database.AddDataSource(ds);
	 SNIPTREE.builder.rebuild( );	
},

//get content from the editor
//A weird, but cool function! :-)  
//Note: We are counting on the fact that this XUL is emebedded in the same page as the Editor !
getEditorContent: function ()
{
	try{
	var editorpage=window.parent.document;
	var editr=editorpage.getElementById("myTextArea");
	var edit_xframe=editorpage.getElementById("xinha_iframe_id");
	var editeddoc=edit_xframe.contentDocument;
	var b=editeddoc.getElementsByTagName("BODY")[0];	
	var str =  b.innerHTML;      
	return str;
	}catch (ex){alert(ex);return null;}
},

getSelectedCode: function ()
{
	var snipcode=null;
	
	try{
	var ds=rdfService.GetDataSourceBlocking(SNIPFILE);
	var dt=this.queryLibTree(1);
	
	//find what contains this date	
	var subject = rdfService.GetResource("http://wysuwyg.mozdev.org/ed-snippets/"+dt);
		
	var snipt = rdfService.GetResource("http://wysuwyg.mozdev.org/rdf#snip-snippet");

	var targetcode = ds.GetTarget(subject, snipt, true);	
	if (targetcode instanceof Components.interfaces.nsIRDFLiteral){
		snipcode = targetcode.Value;
	}
	this.CURRSNIP=""+snipcode;	
	return snipcode ;
	//var libtree=SNIPTREE;
	//libtree.builder.rebuild( );
	} catch(ex) { return ""; }
	
},	


showPrev: function (){
var st=this.getSelectedCode(); 
var dp=document.getElementById('wys_lib_dPrev'); 
//dp.innerHTML=st;
innerXHTML(dp,""+st); //returns a bit weird code, but OK for previewing
}

	
	




}//end class



function startLib(tr,debugflag)
{
  wysLibrary.initLibTree();
  if(tr!= null)
  {
  wysLibrary.updateLibtree(tr);  
  }
}



//drag start observer, will initialize stuff when you drag away

var WYSLIBdrgObserver = { 
  onDragStart: function (evt,transferData,action){
    var txt=wysLibrary.CURRSNIP  ; //evt.target.getAttribute("elem");
    transferData.data=new TransferData();
    transferData.data.addDataForFlavour("text/html",txt);
  }
};
